
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class VotesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const votes = await db.votes.create(
            {
                id: data.id || undefined,
        
        target_type: data.target_type
        ||
        null
            ,
            
        value: data.value
        ||
        null
            ,
            
        voted_at: data.voted_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await votes.setUser( data.user || null, {
            transaction,
        });
        
        await votes.setProblem_report( data.problem_report || null, {
            transaction,
        });
        
        await votes.setSolution_proposal( data.solution_proposal || null, {
            transaction,
        });
        
        await votes.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return votes;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const votesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                target_type: item.target_type
            ||
            null
            ,
            
                value: item.value
            ||
            null
            ,
            
                voted_at: item.voted_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const votes = await db.votes.bulkCreate(votesData, { transaction });

        // For each item created, replace relation files
        

        return votes;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const votes = await db.votes.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.target_type !== undefined) updatePayload.target_type = data.target_type;
        
        
        if (data.value !== undefined) updatePayload.value = data.value;
        
        
        if (data.voted_at !== undefined) updatePayload.voted_at = data.voted_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await votes.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await votes.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.problem_report !== undefined) {
            await votes.setProblem_report(
              
              data.problem_report,
              
              { transaction }
            );
        }
        
        if (data.solution_proposal !== undefined) {
            await votes.setSolution_proposal(
              
              data.solution_proposal,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await votes.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return votes;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const votes = await db.votes.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of votes) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of votes) {
                await record.destroy({transaction});
            }
        });


        return votes;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const votes = await db.votes.findByPk(id, options);

        await votes.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await votes.destroy({
            transaction
        });

        return votes;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const votes = await db.votes.findOne(
            { where },
            { transaction },
        );

        if (!votes) {
            return votes;
        }

        const output = votes.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await votes.getUser({
            transaction
        });
        
        
        output.problem_report = await votes.getProblem_report({
            transaction
        });
        
        
        output.solution_proposal = await votes.getSolution_proposal({
            transaction
        });
        
        
        output.organizations = await votes.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.problem_reports,
        as: 'problem_report',
        
        where: filter.problem_report ? {
          [Op.or]: [
            { id: { [Op.in]: filter.problem_report.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.problem_report.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.solution_proposals,
        as: 'solution_proposal',
        
        where: filter.solution_proposal ? {
          [Op.or]: [
            { id: { [Op.in]: filter.solution_proposal.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.solution_proposal.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.voted_atRange) {
                const [start, end] = filter.voted_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    voted_at: {
                    ...where.voted_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    voted_at: {
                    ...where.voted_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.target_type) {
                where = {
                    ...where,
                target_type: filter.target_type,
            };
            }
            
            if (filter.value) {
                where = {
                    ...where,
                value: filter.value,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.votes.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'votes',
                        'value',
                        query,
                    ),
                ],
            };
        }

        const records = await db.votes.findAll({
            attributes: [ 'id', 'value' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['value', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.value,
        }));
    }

    
};

